clear all

s=linspace(0.5,1.5,1001);
gamma1=0.25;
gamma2=0.75;
K1=s.^(-gamma1);
K2=s.^(-gamma2);

subplot(2,2,1)
Kp1=K1.*(s>=1.2); p1=find(Kp1>0);
Kp2=K2.*(s<=1.2); p2=find(Kp2>0);
plot(s(p1),Kp1(p1),'-k','LineWidth',3)
hold on
plot(s(p2),Kp2(p2),'-k','LineWidth',3)
hold on
plot(s,K1,'--k','LineWidth',2)
hold on
plot(s,K2,'-.k','LineWidth',2)
hold on
plot(s,K1,'--k','LineWidth',2)
hold on
plot(s,K2,'-.k','LineWidth',2)
hold on
scatter([1.2],[0.7],'ko','LineWidth',1, 'MarkerEdgeColor','k','MarkerFaceColor',[.49 1 .63])

ylim([0.7 1.85])
xlabel('Returns')
ylabel('PK')
set(get(gca,'XLabel'),'FontWeight','bold','FontSize',12)
set(get(gca,'YLabel'),'FontWeight','bold','FontSize',12)
set(gca,'FontSize',12,'FontWeight','bold')
set(gca,'XTick',[0.5 1 1.5])
set(gca,'YTick',[0.8 1.3 1.8])
box off

s=linspace(0.5,1.5,1001);
gamma=0.75;
K1=1.1*s.^(-gamma);
K2=s.^(-gamma);

subplot(2,2,2)
Kp1=K1.*(s>=1.2); p1=find(Kp1>0);
Kp2=K2.*(s<=1.2); p2=find(Kp2>0);
plot(s(p1),Kp1(p1),'-k','LineWidth',3)
hold on
plot(s(p2),Kp2(p2),'-k','LineWidth',3)
hold on
plot(s,K1,'--k','LineWidth',2)
hold on
plot(s,K2,'-.k','LineWidth',2)
hold on
scatter([1.2],[0.7],'ko','LineWidth',1, 'MarkerEdgeColor','k','MarkerFaceColor',[.49 1 .63])

ylim([0.7 1.85])
xlabel('Returns')
ylabel('PK')
set(get(gca,'XLabel'),'FontWeight','bold','FontSize',12)
set(get(gca,'YLabel'),'FontWeight','bold','FontSize',12)
set(gca,'FontSize',12,'FontWeight','bold')
set(gca,'XTick',[0.5 1 1.5])
set(gca,'YTick',[0.8 1.3 1.8])
box off

s=linspace(0.5,1.5,1001);
gamma=0.5;
K1=1.2*s.^(-gamma);
K2=s.^(-gamma);
K3=1.1*s.^(-gamma);

subplot(2,2,3)
Kp1=K1.*(s>=1.2); p1=find(Kp1>0);
Kp2=K2.*(s<=1.1); p2=find(Kp2>0);
Kp3=K3.*(s>=0.9 & s<=1.1); p3=find(Kp3>0);
Kp1=K1.*(s>=1.1); p1=find(Kp1>0);
Kp2=K2.*(s<=0.9); p2=find(Kp2>0);
Kp3=K3.*(s>=0.9 & s<=1.1); p3=find(Kp3>0);
plot(s(p1),Kp1(p1),'-k','LineWidth',3)
hold on
plot(s(p2),Kp2(p2),'-k','LineWidth',3)
hold on
plot(s(p3),Kp3(p3),'-k','LineWidth',3)
hold on
plot(s,K1,'--k','LineWidth',2)
hold on
plot(s,K2,'-.k','LineWidth',2)
hold on
plot(s,K3,':k','LineWidth',2)
hold on
scatter([0.9 1.1],[0.7 0.7],'ko','LineWidth',1, 'MarkerEdgeColor','k','MarkerFaceColor',[.49 1 .63])

ylim([0.7 1.85])
xlabel('Returns')
ylabel('PK')
set(get(gca,'XLabel'),'FontWeight','bold','FontSize',12)
set(get(gca,'YLabel'),'FontWeight','bold','FontSize',12)
set(gca,'FontSize',12,'FontWeight','bold')
set(gca,'XTick',[0.5 1 1.5])
set(gca,'YTick',[0.8 1.3 1.8])
box off


subplot(2,2,4)
s=linspace(0.5,1.5,1001);
gamma=0.5;
b=1.2;
K1=b*s.^(-gamma);
K2=s.^(-gamma);
n=5;

r = [0.8732
    0.8960
    1.1546
    0.8115
    0.9960];

for i=1:length(s)
F(i)=1/n*sum((r<=s(i)));
end
K=(s./((1-F)+F*b^(1/gamma))).^(-gamma);
hold on
R=sort(r);
for j=1:length(r)
FF(j)=1/n*sum((r<=R(j)));
end
KK=(R./((1-FF')+FF'*b^(1/gamma))).^(-gamma);
BB=KK./(R.^(gamma))
Ka=BB*s.^(-gamma);
for j=1:length(r)
    Ka(j,:)=(s./((1-FF(j))+FF(j)*b^(1/gamma))).^(-gamma);
plot(s,Ka(j,:),':k','LineWidth',2)
end

hold on
scatter(R,ones(1,5)*0.7,'ko','LineWidth',1, 'MarkerEdgeColor','k','MarkerFaceColor',[.49 1 .63])
hold on
plot(s(1,1:max(find(s<=R(1)))),K2(1:max(find(s<=R(1)))),'-k','LineWidth',3)
hold on
plot(s(min(find(s>=R(1)& s<=R(2))):max(find(s>=R(1)& s<=R(2)))),Ka(1,min(find(s>=R(1)& s<=R(2))):max(find(s>=R(1)& s<=R(2)))),'-k','LineWidth',3)
hold on
plot(s(min(find(s>=R(2)& s<=R(3))):max(find(s>=R(2)& s<=R(3)))),Ka(2,min(find(s>=R(2)& s<=R(3))):max(find(s>=R(2)& s<=R(3)))),'-k','LineWidth',3)
hold on
plot(s(min(find(s>=R(3)& s<=R(4))):max(find(s>=R(3)& s<=R(4)))),Ka(3,min(find(s>=R(3)& s<=R(4))):max(find(s>=R(3)& s<=R(4)))),'-k','LineWidth',3)
hold on
plot(s(min(find(s>=R(4)& s<=R(5))):max(find(s>=R(4)& s<=R(5)))),Ka(4,min(find(s>=R(4)& s<=R(5))):max(find(s>=R(4)& s<=R(5)))),'-k','LineWidth',3)
hold on
plot(s(min(find(s>=R(5))):length(s)),Ka(5,min(find(s>=R(5))):length(s)),'-k','LineWidth',3)


for i=1:length(s)
F(i)=1/n*sum((r<=s(i)));
end
K=(s./((1-F)+F*b^(1/gamma))).^(-gamma);
hold on
plot(s,K1,'--k','LineWidth',2)
hold on
plot(s,K2,'-.k','LineWidth',2)

ylim([0.7 1.85])
xlabel('Returns')
ylabel('PK')
set(get(gca,'XLabel'),'FontWeight','bold','FontSize',12)
set(get(gca,'YLabel'),'FontWeight','bold','FontSize',12)
set(gca,'FontSize',12,'FontWeight','bold')
set(gca,'XTick',[0.5 1 1.5])
set(gca,'YTick',[0.8 1.3 1.8])
box off
