clear all


figure(1)
% GENERATE PRICING KERNEL

gamma = 0.5;
b0 =  1;
b1 = 1.2;

n=5001;
s=linspace(0.5,1.5,n)';
m=4000;
mu1=1;
st=0.050;

F1=normcdf(s,mu1,st);
K1 = (s./((1 - F1)*b0^(1/gamma) + F1*b1^(1/gamma))).^(-gamma);
c1=K1.^(-1/gamma);
c2=(K1/b1).^(-1/gamma);

subplot(2,2,1)
plot(s, K1,'-k','LineWidth',3)
ylim([0.9 1.4])
xlim([0.5 1.5])
xlabel('Returns')
ylabel('PK')
set(get(gca,'XLabel'),'FontWeight','bold','FontSize',12)
set(get(gca,'YLabel'),'FontWeight','bold','FontSize',12)
set(gca,'FontSize',12,'FontWeight','bold')
set(gca,'YTick',[1 1.2 1.4])
set(gca,'XTick',[0.5 1 1.5])
box off


subplot(2,2,2)

C1=K1(1:find(s==1)).^(-1/gamma);
C2=(K1(find(s==1):length(s))/b1).^(-1/gamma);

area(s(1:find(s==1)),s(1:find(s==1)),'FaceColor',[.5 .9 .6],'EdgeColor','w')
hold on
area(s(1:find(s==1)),C1,'FaceColor','w','EdgeColor','w')
hold on
area(s(find(s==1):length(s)),C2,'FaceColor',[.5 .9 .6])
hold on
area(s(find(s==1):length(s)),s(find(s==1):length(s)),'FaceColor','w','EdgeColor','w')
hold on
area(s,c1,'FaceColor','w','EdgeColor','w')

plot(s(1:find(s==1)), C1,'-k','LineWidth',3)
hold on
plot(s(find(s==1):length(s)),C2,'-k','LineWidth',3)
hold on 
plot(s,s,'-.k','LineWidth',2)
hold on
plot([0.5,1.5],[0.5,0.5],'k')
hold on
plot(s, c1,'--k','LineWidth',3)
hold on
plot(s, c2,'--k','LineWidth',3)
hold on
plot([s(find(s==1)),s(find(s==1))],[C1(length(C1)), C2(1)],'-k')
hold on
plot([s(length(s)),s(length(s))],[c1(length(s)), c2(length(s))],'-w')

ylim([0.5 1.5])
xlim([0.5 1.5])
xlabel('Returns')
ylabel('Wealth');
set(get(gca,'XLabel'),'FontWeight','bold','FontSize',12)
set(get(gca,'YLabel'),'FontWeight','bold','FontSize',12)
set(gca,'FontSize',12,'FontWeight','bold')
set(gca,'YTick',[ 1 1.5])
set(gca,'XTick',[0.5 1 1.5])
box off


subplot(2,2,3)

C1=K1(1:find(s==0.9)).^(-1/gamma);
C2=(K1(find(s==0.9):length(s))/b1).^(-1/gamma);

area(s(find(s==0.9):length(s)),C2,'FaceColor','w','EdgeColor','w')
hold on
area(s(1:find(s==0.9)),s(1:find(s==0.9)),'FaceColor',[.5 .9 .6],'EdgeColor','w')
hold on
area(s(1:find(s==0.9)),C1,'FaceColor','w','EdgeColor','w')
hold on
area(s(find(s==0.9):length(s)),C2,'FaceColor',[.5 .9 .6])
hold on
area(s(find(s==0.9):length(s)),s(find(s==0.9):length(s)),'FaceColor','w','EdgeColor','w')
hold on
area(s,c1,'FaceColor','w','EdgeColor','w')


hold on
plot(s(1:find(s==0.9)), C1,'-k','LineWidth',3)
hold on
plot(s(find(s==0.9):length(s)),C2,'-k','LineWidth',3)
hold on 
plot(s,s,'-.k','LineWidth',2)
hold on
plot(s, c1,'--k','LineWidth',3)
hold on
plot(s, c2,'--k','LineWidth',3)
hold on
plot([s(find(s==0.9)),s(find(s==0.9))],[C1(length(C1)), C2(1)],'-k')
hold on
plot([0.5,1.5],[0.5,0.5],'k')
hold on
plot([s(length(s)),s(length(s))],[c1(length(s)), c2(length(s))],'-w')

ylim([0.5 1.5])
xlim([0.5 1.5])
xlabel('Returns')
%ylabel('$$\bar{w}_{i^{\prime}}$$','Interpreter','latex');
ylabel('Wealth');
set(get(gca,'XLabel'),'FontWeight','bold','FontSize',12)
set(get(gca,'YLabel'),'FontWeight','bold','FontSize',12)
set(gca,'FontSize',12,'FontWeight','bold')
set(gca,'YTick',[ 1 1.5])
set(gca,'XTick',[0.5 1 1.5])
box off


subplot(2,2,4)

C1=K1(1:find(s==1.1)).^(-1/gamma);
C2=(K1(find(s==1.1):length(s))/b1).^(-1/gamma);

area(s(1:find(s==1.1)),s(1:find(s==1.1)),'FaceColor',[.5 .9 .6],'EdgeColor','w')
hold on
area(s(1:find(s==1.1)),C1,'FaceColor','w','EdgeColor','w')
hold on
area(s(find(s==1.1):length(s)),C2,'FaceColor',[.5 .9 .6])
hold on
area(s(find(s==1.1):length(s)),s(find(s==1.1):length(s)),'FaceColor','w','EdgeColor','w')
hold on
area(s,c1,'FaceColor','w','EdgeColor','w')
hold on
area(s(find(s==1.1):length(s)),C2,'FaceColor','w','EdgeColor','w')

hold on
plot(s(1:find(s==1.1)), C1,'-k','LineWidth',3)
hold on
plot(s(find(s==1.1):length(s)),C2,'-k','LineWidth',3)
hold on 
plot(s,s,'-.k','LineWidth',2)
hold on
plot(s, c1,'--k','LineWidth',3)
hold on
plot(s, c2,'--k','LineWidth',3)
hold on
plot([s(find(s==1.1)),s(find(s==1.1))],[C1(length(C1)), C2(1)],'-k')
hold on
plot([0.5,1.5],[0.5,0.5],'k')
hold on
plot([s(length(s)),s(length(s))],[c1(length(s)), c2(length(s))],'-w')

ylim([0.5 1.5])
xlim([0.5 1.5])
xlabel('Returns')
ylabel('Wealth');
set(get(gca,'XLabel'),'FontWeight','bold','FontSize',12)
set(get(gca,'YLabel'),'FontWeight','bold','FontSize',12)
set(gca,'FontSize',12,'FontWeight','bold')
set(gca,'YTick',[ 1 1.5])
set(gca,'XTick',[0.5 1 1.5])
box off

