clear all



% GENERATE PRICING KERNEL

delta = 0.5;
b0 =  1;
b1 = 1.2;

n=5000;
s=linspace(0.5,1.5,n)';
m=4000;
mu1=1;
mu2=1.2;
st=0.050;

F1=normcdf(s,mu1,st);
F2=normcdf(s,mu2,st);
K1 = (s./((1 - F1)*b0^(1/delta) + F1*b1^(1/delta))).^(-delta);
K2 = (s./((1 - F2)*b0^(1/delta) + F2*b1^(1/delta))).^(-delta);

subplot(3,2,1)
plot(s, K1,'-k','LineWidth',3)
hold on
plot(s,K2,'--k','LineWidth',3)

ylim([0.8 1.5])
xlim([0.5 1.5])
xlabel('Returns')
ylabel('PK')
set(get(gca,'XLabel'),'FontWeight','bold','FontSize',12)
set(get(gca,'YLabel'),'FontWeight','bold','FontSize',12)
set(gca,'FontSize',12,'FontWeight','bold')
set(gca,'YTick',[1 1.25 1.5])
set(gca,'XTick',[0.5 1 1.5])
box off

% GENERATE PRICING KERNEL

delta = 0.5;
b0 =  1;
b1 = 1.2;

n=5000;
s=linspace(0.5,1.5,n)';
m=4000;
mu=1;
st1=0.050;
st2=0.150;

F1=normcdf(s,mu,st1);
F2=normcdf(s,mu,st2);
K1 = (s./((1 - F1)*b0^(1/delta) + F1*b1^(1/delta))).^(-delta);
K2 = (s./((1 - F2)*b0^(1/delta) + F2*b1^(1/delta))).^(-delta);

subplot(3,2,2)
plot(s, K1,'-k','LineWidth',3)
hold on
plot(s,K2,'--k','LineWidth',3)

ylim([0.8 1.5])
xlim([0.5 1.5])
xlabel('Returns')
ylabel('PK')
set(get(gca,'XLabel'),'FontWeight','bold','FontSize',12)
set(get(gca,'YLabel'),'FontWeight','bold','FontSize',12)
set(gca,'FontSize',12,'FontWeight','bold')
set(gca,'YTick',[1 1.25 1.5])
set(gca,'XTick',[0.5 1 1.5])
box off


% GENERATE PRICING KERNEL

delta = 0.5;
b0 =  1;
b1 = 1.2;
b2 = 1.4;
n=5000;
s=linspace(0.5,1.5,n)';
m=4000;
mu=1;
st1=0.050;

F1=normcdf(s,mu,st1);
F2=normcdf(s,mu,st1);
K1 = (s./((1 - F1)*b0^(1/delta) + F1*b1^(1/delta))).^(-delta);
K2 = (s./((1 - F2)*b0^(1/delta) + F2*b2^(1/delta))).^(-delta);

subplot(3,2,3)
plot(s, K1,'-k','LineWidth',3)
hold on
plot(s,K2,'--k','LineWidth',3)

ylim([0.8 1.5])
xlim([0.5 1.5])
xlabel('Returns')
ylabel('PK')
set(get(gca,'XLabel'),'FontWeight','bold','FontSize',12)
set(get(gca,'YLabel'),'FontWeight','bold','FontSize',12)
set(gca,'FontSize',12,'FontWeight','bold')
set(gca,'YTick',[1 1.25 1.5])
set(gca,'XTick',[0.5 1 1.5])
box off


% GENERATE PRICING KERNEL

delta = 0.5;
delta1 =0.25;
b0 =  1;
b1 = 1.2;
b2 = 1.4;
n=5000;
s=linspace(0.5,1.5,n)';
m=4000;
mu=1;
st1=0.050;

F1=normcdf(s,mu,st1);
F2=normcdf(s,mu,st1);
K1 = (s./((1 - F1)*b0^(1/delta) + F1*b1^(1/delta))).^(-delta);
K2 = (s./((1 - F2)*b0^(1/delta1) + F2*b1^(1/delta1))).^(-delta1);

subplot(3,2,4)
plot(s, K1,'-k','LineWidth',3)
hold on
plot(s,K2,'--k','LineWidth',3)

ylim([0.8 1.5])
xlim([0.5 1.5])
xlabel('Returns')
ylabel('PK')
set(get(gca,'XLabel'),'FontWeight','bold','FontSize',12)
set(get(gca,'YLabel'),'FontWeight','bold','FontSize',12)
set(gca,'FontSize',12,'FontWeight','bold')
set(gca,'YTick',[1 1.25 1.5])
set(gca,'XTick',[0.5 1 1.5])
box off


clear all

% GENERATE PRICING KERNEL

delta = 0.5;
delta1 =0.25;
b0 =  1;
b1 = 1.2;
b2 = 1.4;
n=5000;
s=linspace(0.5,1.5,n)';
m=4000;
mu=1;
st1=0.050;

F1=normcdf(s,mu,st1);
F2=normcdf(s,mu,st1);
K1 = (s./((1 - F1)*b0^(1/delta) + F1*b1^(1/delta))).^(-delta);
K2 = (s./((1 - F2)*b0^(1/delta1) + F2*b1^(1/delta1))).^(-delta1);

options = optimset('TolX', 1e-12, 'TolFun', 1e-12);
gamma0 = 0.5;
gamma1=0.25;
b0=1;
b1=1.2;
F=F1;
for i=1:length(s)
K2(i) = fsolve(@(k)(1-F(i)).*(k/b0).^(-1/gamma0)+F(i).*(k/b1).^(-1/gamma1)-s(i),1,options);
end

subplot(3,2,5)
plot(s, K1,'-k','LineWidth',3)
hold on
plot(s,K2,'--k','LineWidth',3)

ylim([0.8 1.5])
xlim([0.5 1.5])
xlabel('Returns')
ylabel('PK')
set(get(gca,'XLabel'),'FontWeight','bold','FontSize',12)
set(get(gca,'YLabel'),'FontWeight','bold','FontSize',12)
set(gca,'FontSize',12,'FontWeight','bold')
set(gca,'YTick',[1 1.25 1.5])
set(gca,'XTick',[0.5 1 1.5])
box off

clear all



% GENERATE PRICING KERNEL

delta = 0.5;
b0 =  1;
b1 = 1.2;

n=5000;
s=linspace(0.5,1.5,n)';
m=4000;
mu1=1;
mu2=1.2;
st=0.050;

F1=normcdf(s,mu1,st);
F2=0.5*F1;
K1 = (s./((1 - F1)*b0^(1/delta) + F1*b1^(1/delta))).^(-delta);
delta2=1.5;
K2 = (s./((1 - F2)*b0^(1/delta) + F2*b1^(1/delta))).^(-delta);

subplot(3,2,6)
plot(s, K1,'-k','LineWidth',3)
hold on
plot(s,K2,'--k','LineWidth',3)

ylim([0.8 1.5])
xlim([0.5 1.5])
xlabel('Returns')
ylabel('PK')
set(get(gca,'XLabel'),'FontWeight','bold','FontSize',12)
set(get(gca,'YLabel'),'FontWeight','bold','FontSize',12)
set(gca,'FontSize',12,'FontWeight','bold')
set(gca,'YTick',[1 1.25 1.5])
set(gca,'XTick',[0.5 1 1.5])
box off