clear all
% GENERATE PRICING KERNEL

delta = 0.5;
b0 =  1;
b1 = 1.2;

n=1001;
s=linspace(0.5,1.5,n)';
m=1000;
mu=1;
st=0.12;

r=normrnd(mu,st,m,1);
for i=1:length(s)
F(i,1)=1/m*sum((r<=s(i)));
end

K = (s./((1 - F)*b0^(1/delta) + F*b1^(1/delta))).^(-delta);
FF=F;
subplot(2,2,1)

plot(s(find(F>0 & F<1)),K(find(F>0 & F<1)),'-k','LineWidth',3)
hold on
plot(s(find(F==0)), K(find(F==0)),'-.k','LineWidth',3)
hold on
plot(s(find(F==1)), K(find(F==1)),'-.k','LineWidth',3)
ylim([0.9 1.4])
xlim([0.5 1.5])
xlabel('Returns')
ylabel('PK')
set(get(gca,'XLabel'),'FontWeight','bold','FontSize',12)
set(get(gca,'YLabel'),'FontWeight','bold','FontSize',12)
set(gca,'FontSize',12,'FontWeight','bold')
set(gca,'YTick',[1 1.2 1.4])
set(gca,'XTick',[0.5 1 1.5])
box off


% modify F and gamma
subplot(2,2,3)
plot(s(find(F>0 & F<1)),FF(find(F>0 & F<1)),'-k','LineWidth',3)
hold on
plot(s(find(F==0)), F(find(F==0)),'-.k','LineWidth',3)
hold on
plot(s(find(F==1)), F(find(F==1)),'-.k','LineWidth',3)
ylim([-0.01 1.01])
xlim([0.5 1.5])
xlabel('Returns')
ylabel('F')
set(get(gca,'XLabel'),'FontWeight','bold','FontSize',12)
set(get(gca,'YLabel'),'FontWeight','bold','FontSize',12)
set(gca,'FontSize',12,'FontWeight','bold')
set(gca,'YTick',[0 0.5 1])
set(gca,'XTick',[0.5 1 1.5])
box off




% GENERATE PRICING KERNEL

delta = 0.5;
b0 =  1;
b1 = 1.2;

n=1001;
s=linspace(0.5,1.5,n)';
m=4000;
mu=1;
st=0.12;

F=FF;

K = (s./((1 - F)*b0^(1/delta) + F*b1^(1/delta))).^(-delta);
FF=F;
subplot(2,2,2)
plot(s, K,'-k','LineWidth',3)
hold on
plot(s(find(F==0)), K(find(F==0)),'-r','LineWidth',3)
hold on
plot(s(find(F==1)), K(find(F==1)),'-r','LineWidth',3)
ylim([1.05 1.175])
xlim([0.75 1.25])
xlabel('Returns')
ylabel('PK')
set(get(gca,'XLabel'),'FontWeight','bold','FontSize',12)
set(get(gca,'YLabel'),'FontWeight','bold','FontSize',12)
set(gca,'FontSize',12,'FontWeight','bold')
set(gca,'YTick',[1.08 1.12 1.16])
set(gca,'XTick',[0.8 1 1.2])
box off

% modify F and gamma
subplot(2,2,4)
b=1.2;
hold on
for j=46:51
    gamma=j/100;
F=(s.*K.^(1/gamma)-1)/(b1.^(1/gamma)-1);
plot(s,F,'--k','LineWidth',2)
hold on
end
hold on
plot(s,FF,'-k','LineWidth',3)
hold on
plot(s(find(F==0)), F(find(F==0)),'-r','LineWidth',3)
hold on
plot(s(find(F==1)), F(find(F==1)),'-r','LineWidth',3)

b1=1.3;
hold on
for j=46:51
    gamma=j/100;
F=(s.*K.^(1/gamma)-1)/(b1.^(1/gamma)-1);
plot(s,F,'--k','LineWidth',2)
hold on
end

b1=1.5;
hold on
for j=46:51
    gamma=j/100;
F=(s.*K.^(1/gamma)-1)/(b1.^(1/gamma)-1);
plot(s,F,'--k','LineWidth',2)
hold on
end

ylim([-0.01 1.01])
xlim([0.75 1.25])
xlabel('Returns')
ylabel('F')
set(get(gca,'XLabel'),'FontWeight','bold','FontSize',12)
set(get(gca,'YLabel'),'FontWeight','bold','FontSize',12)
set(gca,'FontSize',12,'FontWeight','bold')
set(gca,'YTick',[0 0.5 1])
set(gca,'XTick',[0.8 1 1.2])
box off

